searchNodes=[{"doc":"Functions to support setting the locale for Cldr and/or Gettext from the session.","ref":"Cldr.Plug.html","title":"Cldr.Plug","type":"module"},{"doc":"Puts the locale from the session into the current process for Cldr and/or Gettext . This function is useful to place in the on_mount callback for a LiveView. Arguments session is any map, typically the map returned as part of the conn of a Phoenix or Plug request, A session is passed as the third parameter to the on_mount callback of a LiveView request. applications is a list of applications for which the locale may be set. The valid options are :cldr and :gettext . The default is [:cldr, :gettext] Returns {:ok, locale} or {:error, {exception, reason}} Example =&gt; Cldr.Plug . put_locale_from_session ( session ) =&gt; Cldr.Plug . put_locale_from_session ( session , [ :cldr ] ) =&gt; Cldr.Plug . put_locale_from_session ( session , [ :cldr , :gettext ] ) # In a LiveView def on_mount ( :default , _params , session , socket ) do { :ok , locale } = Cldr.Plug . put_locale_from_session ( session ) end","ref":"Cldr.Plug.html#put_locale_from_session/2","title":"Cldr.Plug.put_locale_from_session/2","type":"function"},{"doc":"","ref":"Cldr.Plug.html#t:application/0","title":"Cldr.Plug.application/0","type":"type"},{"doc":"","ref":"Cldr.Plug.html#t:applications/0","title":"Cldr.Plug.applications/0","type":"type"},{"doc":"Parses the accept-language header if one is available and sets conn.private[:cldr_locale] accordingly. The locale can be later retrieved by Cldr.Plug.AcceptLanguage.get_cldr_locale/1 Options :cldr_backend is any backend module. The default is Cldr.default_backend/0 . If no :cldr_backend option is provided and no default backend is configured then an exception will be raised. :no_match_log_level determines the logging level for the case when no matching locale is configured to meet the users request. The default is :warn . If set to nil then no logging is performed. Example # Using a specific backend to validate # and match locales plug Cldr.Plug.AcceptLanguage , cldr_backend : MyApp.Cldr # Using the default backend to validate # and match locales plug Cldr.Plug.AcceptLanguage","ref":"Cldr.Plug.AcceptLanguage.html","title":"Cldr.Plug.AcceptLanguage","type":"module"},{"doc":"Returns the locale which is the best match for the provided accept-language header","ref":"Cldr.Plug.AcceptLanguage.html#best_match/2","title":"Cldr.Plug.AcceptLanguage.best_match/2","type":"function"},{"doc":"Return the locale set by Cldr.Plug.AcceptLanguage","ref":"Cldr.Plug.AcceptLanguage.html#get_cldr_locale/1","title":"Cldr.Plug.AcceptLanguage.get_cldr_locale/1","type":"function"},{"doc":"Puts the Cldr and/or Gettext locales derived from the accept-language header, a query parameter, a url parameter, a body parameter, the route or the session for the current process with Cldr.put_locale/2 and/or Gettext.put_locale/2 . Options :apps - list of apps for which to set locale. See the apps configuration section. :from - where in the request to look for the locale. The default is [:session, :accept_language, :query, :path, :route] . The valid options are: :accept_language will parse the accept-language header and finds the best matched configured locale :path will look for a locale by examining conn.path_params :query will look for a locale by examining conn.query_params :body will look for a locale by examining conn.body_params :cookie will look for a locale in the request cookie(s) :session will look for a locale in the session :route will look for a locale in the route that was matched under the key private.:cldr_locale . The key may be populated by a Phoenix router and it is used extensively by the ex_cldr_routes library. Note that any locale set in the route represents the locale defined for the route, not necessarily one requested by the user. Therefore setting the locale from the :route key should be a lower priority than other methods based on the actual request. :host will attempt to resolve a locale from the host name top-level domain using Cldr.Locale.locale_from_host/3 {Module, function, args} in which case the indicated function will be called. If it returns {:ok, locale} then the locale is set to locale . locale must be a t:Cldr.LanguageTag.t() . Any other return is considered an error and no locale will be set. When calling the function, conn and options will be prepended to args . {Module, function} in which case the function is called with conn and options as its two arguments. All other behaviour is the same as that for a {Module, function, args} option. :default - the default locale to set if no locale is found by other configured methods. It can be a string like &quot;en&quot; or a Cldr.LanguageTag struct. It may also be :none to indicate that no locale is to be set by default. Lastly, it may also be a {Module, function, args} or {Module, function} tuple. The default is Cldr.default_locale/1 . If the case of {Module, function, args} , a return of {:ok, %Cldr.LanguageTag{}} will set the locale. Any other return will not set a locale. :gettext - the name of the Gettext backend module upon which the locale will be validated. This option is not required if a gettext module is specified in the :apps configuration. :cldr - the name of the Cldr backend module upon which the locale will be validated. This option is not required if a gettext module is specified in the :apps configuration. :session_key - defines the key used to look for the locale in the session. The default is cldr_locale . This option is deprecated and will be removed in a future release. The session key is being standardised in order to faciliate a simpler integration with Phoenix LiveView by ensuring that the session key is always under a well known key. If a locale is found then conn.private[:cldr_locale] is also set. It can be retrieved with Cldr.Plug.PutLocale.get_cldr_locale/1 . App configuration The :apps configuration key defines which applications will have their locale set by this plug. Cldr.Plug.PutLocale can set the locale for cldr , gettext or both. The basic configuration of the :app key is an atom, or list of atoms, containing one or both of these app names. For example: apps : :cldr apps : :gettext apps : [ :cldr , :gettext ] In each of these cases, the locale is set globally for the current process . Sometimes setting the locale for only a specific backend is required. In this case, configure the :apps key as a keyword list pairing an application with the required backend module. The value :global signifies setting the local for the global context. For example: apps : [ cldr : MyApp.Cldr ] apps : [ gettext : MyAppGettext ] apps : [ gettext : :global ] apps : [ cldr : MyApp.Cldr , gettext : MyAppGettext ] Using Cldr.Plug.PutLocale without Phoenix If you are using Cldr.Plug.PutLocale without Phoenix and you plan to use :path_param to identify the locale of a request then Cldr.Plug.PutLocale must be configured after plug :match and before plug :dispatch . For example: defmodule MyRouter do use Plug.Router plug :match plug Cldr.Plug.PutLocale , apps : [ :cldr , :gettext ] , from : [ :path , :query ] , gettext : MyApp.Gettext , cldr : MyApp.Cldr plug :dispatch get &quot;/hello/:locale&quot; do send_resp ( conn , 200 , &quot;world&quot; ) end end Using Cldr.Plug.PutLocale with Phoenix If you are using Cldr.Plug.PutLocale with Phoenix and you plan to use the :path_param to identify the locale of a request then Cldr.Plug.PutLocale must be configured in the router module, not in the endpoint module. This is because conn.path_params has not yet been populated in the endpoint. For example: defmodule MyAppWeb.Router do use MyAppWeb , :router pipeline :browser do plug :accepts , [ &quot;html&quot; ] plug :fetch_session plug Cldr.Plug.PutLocale , apps : [ :cldr , :gettext ] , from : [ :path , :query ] , gettext : MyApp.Gettext , cldr : MyApp.Cldr plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end scope &quot;/:locale&quot; , HelloWeb do pipe_through :browser get &quot;/&quot; , PageController , :index end end Examples # Will set the global locale for the current process # for both `:cldr` and `:gettext` plug Cldr.Plug.PutLocale , apps : [ :cldr , :gettext ] , from : [ :query , :path , :body , :cookie , :accept_language ] , param : &quot;locale&quot; , gettext : GetTextModule , cldr : MyApp.Cldr # Will set the backend-only locale for the current process # for both `:cldr` and `:gettext` plug Cldr.Plug.PutLocale , apps : [ cldr : MyApp.Cldr , gettext : GetTextModule ] , from : [ :query , :path , :body , :cookie , :accept_language ] , param : &quot;locale&quot; # Will set the backend-only locale for the current process # for `:cldr` and globally for `:gettext` plug Cldr.Plug.PutLocale , apps : [ cldr : MyApp.Cldr , gettext : :global ] , from : [ :query , :path , :body , :cookie , :accept_language ] , param : &quot;locale&quot;","ref":"Cldr.Plug.PutLocale.html","title":"Cldr.Plug.PutLocale","type":"module"},{"doc":"Return the locale set by Cldr.Plug.PutLocale","ref":"Cldr.Plug.PutLocale.html#get_cldr_locale/1","title":"Cldr.Plug.PutLocale.get_cldr_locale/1","type":"function"},{"doc":"Returns the name of the session key used to store the CLDR locale name. Example iex&gt; Cldr.Plug.PutLocale.session_key() &quot;cldr_locale&quot;","ref":"Cldr.Plug.PutLocale.html#session_key/0","title":"Cldr.Plug.PutLocale.session_key/0","type":"function"},{"doc":"Puts the CLDR locale in the session. The session key is fixed to be cldr_locale in order that downstream functions like those in liveview don't have to be passed options. Options :as is an options that determines the format in which the locale is saved in the session. That valid settings for this options are: :string in which the current locale is converted to a string before storing in the session. It will then be parsed back into a %Cldr.LanguageTag{} upon reading it from the session. This option has the benefit that it will minimise space used in the session at the expense of the CPU time required to serialized and parse. The average size of commonly used locales is under 10 bytes and often less than 5. :language_tag in which the current locale is stored in the session in its native %Cldr.LanguageTag{} format. This has the benefit of minimizing CPU time serialising and parsing the locale at the expense of a larger payment size in the session. The average size of a language tag struct, when serialized, is around 500 bytes. The default is as: :string . Examples # Define a router module that # sets the locale for the current process # and then also sets it in the session defmodule MyAppWeb.Router do use MyAppWeb , :router pipeline :browser do plug :accepts , [ &quot;html&quot; ] plug :fetch_session plug Cldr.Plug.PutLocale , apps : [ :cldr , :gettext ] , from : [ :path , :query ] , gettext : MyApp.Gettext , cldr : MyApp.Cldr plug Cldr.Plug.PutSession , as : :string plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end end","ref":"Cldr.Plug.PutSession.html","title":"Cldr.Plug.PutSession","type":"module"},{"doc":"","ref":"readme.html","title":"Cldr Plug","type":"extras"},{"doc":"Cldr provides two plugs to aid integration into an HTTP workflow. These two plugs are: Cldr.Plug.AcceptLanguage which will parse an accept-language header and resolve the best matched and configured Cldr locale. The result is stored in conn.private[:cldr_locale] which is also returned by Cldr.Plug.AcceptLanguage.get_cldr_locale/1 . Cldr.Plug.PutLocale which will look for a locale in the several places and then call Cldr.put_locale/2 and Gettext.put_locale/2 if configured so to do. Finally, The result is stored in conn.private[:cldr_locale] which is then available through Cldr.Plug.PutLocale.get_cldr_locale/1 . The plug will look for a locale in the following locations depending on the plug configuration: path_params query_params body_params cookies accept-language header Hostname suffix the session An {Module, function, [args]} or {Module, function} tuple that should return {:ok, Cldr.LanguageTag.t()} - any other return will not set the locale. See Cldr.Plug.PutLocale for a description of how to configure the plug. In addition, note that when migrating from ex_cldr 1.x versions, a backend needs to be configured for both plugs. In the simplest case an example would be: plug Cldr.Plug.PutLocale , apps : [ :cldr ] , cldr : MyApp.Cldr plug Cldr.Plug.AcceptLanguage , cldr_backend : MyApp.Cldr Using Cldr.Plug.PutLocale without Phoenix If you are using Cldr.Plug.PutLocale without Phoenix and you plan to use :path_param to identify the locale of a request then Cldr.Plug.PutLocale must be configured after plug :match and before plug :dispatch . For example: defmodule MyRouter do use Plug.Router plug :match plug Cldr.Plug.PutLocale , apps : [ :cldr , :gettext ] , from : [ :path , :query ] , gettext : MyApp.Gettext , cldr : MyApp.Cldr plug :dispatch get &quot;/hello/:locale&quot; do send_resp ( conn , 200 , &quot;world&quot; ) end end Using Cldr.Plug.PutLocale with Phoenix If you are using Cldr.Plug.PutLocale with Phoenix and you plan to use the :path_param to identify the locale of a request then Cldr.Plug.PutLocale must be configured in the router module, not in the endpoint module. This is because conn.path_params has not yet been populated in the endpoint. For example: defmodule MyAppWeb.Router do use MyAppWeb , :router pipeline :browser do plug :accepts , [ &quot;html&quot; ] plug :fetch_session plug Cldr.Plug.PutLocale , apps : [ :cldr , :gettext ] , from : [ :path , :query ] , gettext : MyApp.Gettext , cldr : MyApp.Cldr plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers end scope &quot;/:locale&quot; , HelloWeb do pipe_through :browser get &quot;/&quot; , PageController , :index end end","ref":"readme.html#plugs","title":"Cldr Plug - Plugs","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is the changelog for Cldr Plugs v1.2.1 released on January 30th, 2023. For older changelogs please consult the release tag on GitHub Bug Fixes Improves logger messages when Cldr.Plug.PutLocale is attempting to set the Gettext locale. There are now one of two warnings logged: One when the CLDR backend module has no configured Gettext module One when there is a configured Gettext module but that module does not have the specified locale configured. Changes Logger.warn/1 to Logger.warning/1 to avoid deprecation messages on Elixir 1.15","ref":"changelog.html#cldr-plugs-v1-2-1","title":"Changelog - Cldr Plugs v1.2.1","type":"extras"},{"doc":"This is the changelog for Cldr Plugs v1.2.0 released on July 27th, 2022. For older changelogs please consult the release tag on GitHub Deprecations Deprecate Cldr.Plug.SetLocale in favour of the more consistent Cldr.Plug.PutLocale name. Deprecate the :assigns from key in favour of they key :route . Cldr.Route will, as of version 0.5.0, place the locale in the conn.private.cldr_locale location. from: :route better reflects the intent. The :assigns keyword remains valid with a deprecation warning. Bug Fixes Fix setting the locale from the result returned from an {M, f} or {M, f, [a]} . Thanks to @rubas for the PR. Don't make modules Cldr.Plug.AcceptLanguage and Cldr.Plug.PutSession dependent on Plug , Plug is a required dependency since this library was split from ex_cldr . Thanks to @linusdm for the report. Closes #1. Enhancements Adds Cldr.Plug.put_locale_from_session/2 that takes the locale from the session (if there is one) and puts the Cldr locale and/or the Gettext locale into the current process. This is very useful to add to the on_mount callback in LiveView but it can be applied at any time the session is available. For example: def on_mount ( :default , _params , session , socket ) do { :ok , locale } = Cldr.Plug . put_locale_from_session ( session ) ... . end Cldr.Plug.PutSession now has the option to store the full %Cldr.LanguageTag{} into the session, or just the string representation (which the default and the same as previous releases). The tradeoff is space used the session (less than 10 bytes typically for the string, around 500 bytes for the struct) versus the performance hit serializing and parsing the locale when storing it in the session or retrieving it later on.","ref":"changelog.html#cldr-plugs-v1-2-0","title":"Changelog - Cldr Plugs v1.2.0","type":"extras"},{"doc":"This is the changelog for Cldr Plugs v1.1.0 released on July 17th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Adds :assigns as an optional source of the locale in Cldr.Plug.SetLocale . The library ex_cldr_routes introduces localised routing. These localised routes will set the conn.assigns[:cldr_locale] and therefore may be used as an indicator of the users locale preference if no other locale source (like the session, path or params) can be identified. Since the routes locale is tied to the route, not necessarily the users preference, this should be considered a lower priority locale source. The default :from parameter is updated to reflect this and is now set to [:session, :accept_language, :query, :path, :assigns] .","ref":"changelog.html#cldr-plugs-v1-1-0","title":"Changelog - Cldr Plugs v1.1.0","type":"extras"},{"doc":"This is the changelog for Cldr Plugs v1.0.0 released on May 10th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Intiial release, extracted from ex_cldr Adds support for MFA (and the variant without arguments MF ) tuples that can be used as part of the Cldr.Plug.SetLocale configuration in the :from and :default cases.","ref":"changelog.html#cldr-plugs-v1-0-0","title":"Changelog - Cldr Plugs v1.0.0","type":"extras"},{"doc":"","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"Copyright 2017 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html#license","title":"LICENSE - License","type":"extras"}]